Distribution:	CCux
Packager:	Christian Wasem <wasem@ccux-linux.de>

Name:		freeimage
Version:	3.10.0
Release:	2
Summary:	Multi-format image decoder library
Group:		System/Libraries
License:	GNU/GPL+ MPLv1.0
URL:		http://freeimage.sourceforge.net/
Source0:	http://downloads.sourceforge.net/%{name}/FreeImage3100.zip
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

Patch0:		FreeImage-3.10.0-syslibs.patch
Patch1:		FreeImage-3.10.0-doxygen.patch

#Automatically resolved build dependencies
BuildRequires: glibc-devel
BuildRequires: ilmbase-devel
BuildRequires: libgcc
BuildRequires: libjpeg-devel
BuildRequires: libmng-devel
BuildRequires: libpng-devel
BuildRequires: libstdc++-devel
BuildRequires: libtiff-devel
BuildRequires: OpenEXR-devel
BuildRequires: openjpeg-devel
BuildRequires: zlib-devel

%description
FreeImage is an Open Source library project for developers who
would like to support popular graphics image formats like PNG,
BMP, JPEG, TIFF and others as needed by today's multimedia
applications. FreeImage is easy to use, fast, multithreading
safe, compatible with all 32-bit versions of Windows, and
cross-platform (works both with Linux and Mac OS X).

%package	devel
Summary:	%{name} development headers.
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description	devel
Header and include files for developing applications with %{name}.

%pre

%preun

%post
ldconfig

%postun
ldconfig

%prep
%setup -q -n FreeImage
%patch0 -p1 -z .syslibs
%patch1 -p1

touch -r Source/FreeImage.h.syslibs Source/FreeImage.h

# remove all included libs to make sure these don't get used during compile
rm -r Source/Lib* Source/ZLib Source/OpenEXR

# some encoding / line ending cleanups
iconv -f ISO-8859-1 -t UTF-8 Whatsnew.txt > Whatsnew.txt.tmp
touch -r Whatsnew.txt Whatsnew.txt.tmp
mv Whatsnew.txt.tmp Whatsnew.txt
sed -i 's/\r//g' Whatsnew.txt license-*.txt gensrclist.sh \
  Wrapper/FreeImagePlus/WhatsNew_FIP.txt

%build
sh ./gensrclist.sh
make %{?_smp_mflags} COMPILERFLAGS="$RPM_OPT_FLAGS -fPIC -fvisibility=hidden `pkg-config --cflags OpenEXR`"

# build libfreeimageplus DIY, as the provided makefile makes libfreeimageplus
# contain a private copy of libfreeimage <sigh>
FIP_OBJS=
for i in Wrapper/FreeImagePlus/src/fip*.cpp; do
  gcc -o $i.o $RPM_OPT_FLAGS -fPIC -fvisibility=hidden \
    -ISource -IWrapper/FreeImagePlus -c $i
  FIP_OBJS="$FIP_OBJS $i.o"
done

gcc -shared -LDist -o Dist/lib%{name}plus-%{version}.so -Wl,-soname,lib%{name}plus.so.3 $FIP_OBJS -lfreeimage-%{version}

pushd Wrapper/FreeImagePlus/doc
doxygen FreeImagePlus.dox
popd

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%_libdir
mkdir -p $RPM_BUILD_ROOT%_includedir

install -m 755 Dist/lib%{name}-%{version}.so $RPM_BUILD_ROOT%_libdir
ln -s lib%{name}-%{version}.so $RPM_BUILD_ROOT%_libdir/lib%{name}.so.3
ln -s lib%{name}-%{version}.so $RPM_BUILD_ROOT%_libdir/lib%{name}.so

install -m 755 Dist/lib%{name}plus-%{version}.so $RPM_BUILD_ROOT%_libdir
ln -s lib%{name}plus-%{version}.so $RPM_BUILD_ROOT%_libdir/lib%{name}plus.so.3
ln -s lib%{name}plus-%{version}.so $RPM_BUILD_ROOT%_libdir/lib%{name}plus.so

install -p -m 644 Source/FreeImage.h $RPM_BUILD_ROOT%_includedir
install -p -m 644 Wrapper/FreeImagePlus/FreeImagePlus.h $RPM_BUILD_ROOT%_includedir

%files
%defattr(-,root,root)
%doc Whatsnew.txt license-*.txt Wrapper/FreeImagePlus/WhatsNew_FIP.txt
%_libdir/lib%{name}*-%{version}.so
%_libdir/lib%{name}*.so.3

%files devel
%defattr(-,root,root)
%doc Wrapper/FreeImagePlus/doc/html
%_includedir
%_libdir/lib%{name}.so
%_libdir/lib%{name}plus.so

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Mon Oct 12 2009 Christian Wasem <wasem@ccux-linux.de> 3.10.0-2
- rebuild against libjpeg-7
* Sat Apr 18 2009 Christian Wasem <wasem@ccux-linux.de> 3.10.0-1
- initial CCux package release
